# Understanding the Folder Structure

In a normal server environment, everything is in one folder and a big giant mess to navigate.
And database files are next to config files!

When using `mcman`, your folder structure will look something like this:

```yaml
cool_server
├─ server.toml
├─ config/
│  └─ ...
└─ server/ #(1)!
   └─ ...
```

1. This folder should be inside `.gitignore`, so you shouldn't see it in most Github repositories.

Inside the folder for your server ('cool_server' in this case), you'll see a few files and folders:

## `server.toml`

This is the configuration file for your server. It contains useful metadata such as:

- What software the server runs on
- What mods or plugins it has
- Additional worlds with datapacks or client-side mods
- Launcher and markdown configurations

These are all can be found under [this section](../reference/server.toml.md) in the reference.

## config/ Directory

Your server's configuration files which you have overridden (edited) should all be here.

When [building](./building.md), mcman uses this folder to create the server's configuration files while also using the server's [variables](./variables.md)

## server/ Directory

This is the 'output' file. It will contain all of the server files including the server jar file after every build.

## Other

- **`client-config/`** folder can be used like `config/` to add client-side config overrides. This folder is processed while exporting to `.mrpack` or `packwiz` - it does nothing while building.
- **`.gitignore`** is the default gitignore file generated by mcman. if you need it and dont have it, you can use [`mcman env gitignore`](../commands/env.md#mcman-env-gitignore)
- **`.dockerignore` & `Dockerfile`** are the default docker files. like gitignore you can use [`mcman env docker`](../commands/env.md#mcman-env-docker)
